=begin
**
** find.rb
** 25 June 2009
**
** Desc:
** This extension can be used to find elements already on the repository. 
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

module Extensions
  # This module provides a methods to find nodes
  # Actions:
  # [+node+] finds a node in the repository
  class Find < Extensions::Namespace


    #----------------------------------------------------- private methods
    private

    #----------------------------------------------------- Dispatcher implementation
    INFO = {
      :namespace => 'find',
      :description => 'find elements in the repository',
      :commands => {
        'node' => {
          :desc => 'Find a node in the repository and display associated information.',
          :syntax => [
          {
            :required => true,
            :label => 'node_id',
            :desc => 'The id of the node.',
            :regexp => /^\d*$/
          }
          ]
        },
        'node_by_name' => {
          :desc => 'Find a node in the repository by its name and display associated information.',
          :syntax => [
          {
            :required => true,
            :label => 'node_name',
            :desc => 'The name of the node.',
            :regexp => /.*$/
          }
          ]
        }
      }
    }

    # Implements the find node fucntionality. See the above for allowed parameters
    def node(*args)
      @controller.request_service(:model_knowledge_refresh )
      # call the service provider to find a node with the specified parameters
      node = @controller.request_service(:model_find_node, args[1] )
      if (node)
        return "Node found: #{node.label}"
      else
        return "No node was found whose id is: #{args[1]}"
      end
    end

    # Implements the find node by name fucntionality. See the above for allowed parameters
    def node_by_name(*args)
      @controller.request_service(:model_knowledge_refresh )
      # call the service provider to find a node with the specified parameters
      node = @controller.request_service(:model_find_node_by_name, args[1] )
      if (node)
        return "Node found: #{node.id}"
      else
        return "No node was found whose name is: #{args[1]}"
      end
    end


  end

end
